//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <StrUtils.Hpp>

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SendButtonClick(TObject *Sender)
{
   TRAII_DisableEnable<TButton> E1( SendButton );

   bool  SystemOk = true;

   TMemoryStream *MS = NULL;

   try
   {
      MS = new TMemoryStream();
      MS->Position = 0;
   }
   catch ( const Exception &e )
   {
      SystemOk = false;
      MessageDlg( "Internal Error : new TMemoryStream",
                  mtError, TMsgDlgButtons() << mbOK, 0 );
      return;
   }

   TEdit *EditsList[] =
   {
      HostIDEdit,   VerzijaEdit,  ID0Edit,        ObjekatEdit,
      ar11Edit,     ar12Edit,     ar13Edit,       ar14Edit,
      KorisnikEdit, ar21Edit,     ar22Edit,       KomandaEdit,
      ar31Edit,     ar32Edit,     ar33Edit,       ar34Edit,
      ar35Edit,     ar36Edit,     ar37Edit,       ar38Edit,
      DatumEdit,    VremeEdit,    Napomena1Edit,  Napomena2Edit
   };


   bool IsCorrected = false;
   int Count = sizeof( EditsList ) / sizeof( TEdit* );

   try
   {
      AnsiString TEMP1, TEMP2;

      // TEdit-s
      for ( int i=0; i<Count; i++ )
      {
         TEMP1 = EditsList[i]->Text;
         TEMP2 = AnsiReplaceStr( TEMP1, ",", "" );

         if ( TEMP1 != TEMP2 )
            IsCorrected = true;

         MS->Write( TEMP2.c_str(), TEMP2.Length() );
         MS->Write( ",", 1 );
      }
      // TMemo
      TEMP1 = DokumentMemo->Text;
      TEMP2 = AnsiReplaceStr( TEMP1, ",", "" );

      if ( TEMP1 != TEMP2 )
         IsCorrected = true;

      MS->Write( TEMP2.c_str(), TEMP2.Length() );

   }
   catch ( const Exception &e )
   {
      SystemOk = false;
      delete MS;
      MessageDlg( "Internal Error : Preparng TMemoryStream",
                  mtError, TMsgDlgButtons() << mbOK, 0 );
   }

   if ( IsCorrected && SystemOk )
   {
      MessageDlg( "Some changes were made to the entry!",
                    mtError, TMsgDlgButtons() << mbOK, 0 );

   }

   MS->Position = 0;

   if ( SystemOk )
   {

      try
      {
         try
         {
            // CONNECTING
            IdTCPClient->Host = HostEdit->Text;
            IdTCPClient->Port = StrToInt( PortEdit->Text );

            IdTCPClient->Connect(5000);
         }
         catch ( const Exception &e )
         {
            SystemOk = false;
            // INFORMATION
            ListBox1->Items->Add( "Server was not found!" );
         }

         if ( SystemOk )
         {

            // SENDING TASKS
            IdTCPClient->WriteInteger( MS->Size );
            ListBox1->Items->Add( "Sent size..." );
            IdTCPClient->WriteStream( MS, MS->Size );
            ListBox1->Items->Add( "Sent stream..." );
            // RECEIVING TASKS

            TMemoryStream *InboxMemoryStream = new TMemoryStream;

            int BytesToRead = IdTCPClient->ReadInteger();
            ListBox1->Items->Add( "Received size..." );
            IdTCPClient->ReadStream( InboxMemoryStream, BytesToRead, false );
            ListBox1->Items->Add( "Received stream..." );

            InboxMemoryStream->SaveToFile( "C:\\received.txt" );

            delete InboxMemoryStream;


         }
      }
      __finally
      {
         if ( IdTCPClient->Connected() )
            IdTCPClient->Disconnect();
      }

   }

   if ( MS )
      delete MS;

}
//---------------------------------------------------------------------------

