//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <Buttons.hpp>

//---------------------------------------------------------------------------
class TServerMainForm : public TForm
{
__published:	// IDE-managed Components
        TPageControl *PageControl;
        TButton *OkButton;
        TTabSheet *LogsTabSheet;
        TTabSheet *ConnectionsTabSheet;
        TTabSheet *ServiceTabSheet;
        TLabel *KonekcijeLabel;
        TBevel *PortBevel;
        TEdit *PortEdit;
        TButton *StartButton;
        TButton *PauseButton;
        TButton *ContinueButton;
        TButton *StopButton;
        TPanel *StatusPanel;
        TButton *RefreshButton;
        TButton *DetailsButton;
        TLabel *PortLabel;
        TLabel *LogLabel;
        TBevel *LogBevel;
        TCheckBox *LogCheckBox;
        TEdit *LogEdit;
        TLabel *LogKbLabel;
        TButton *SendButton;
        void __fastcall FormKeyPress(TObject *Sender, char &Key);
        void __fastcall FormActivate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall OkButtonClick(TObject *Sender);
        void __fastcall PageControlChange(TObject *Sender);
        void __fastcall PageControlChanging(TObject *Sender,
          bool &AllowChange);
        void __fastcall RefreshButtonClick(TObject *Sender);
        void __fastcall DetailsButtonClick(TObject *Sender);
        void __fastcall StartButtonClick(TObject *Sender);
        void __fastcall PauseButtonClick(TObject *Sender);
        void __fastcall ContinueButtonClick(TObject *Sender);
        void __fastcall StopButtonClick(TObject *Sender);
        void __fastcall SendButtonClick(TObject *Sender);
        void __fastcall LogCheckBoxClick(TObject *Sender);
        void __fastcall PortEditChange(TObject *Sender);
        void __fastcall LogEditChange(TObject *Sender);
private:	// User declarations

        bool SetIniValue( AnsiString Section, AnsiString Key, AnsiString Value );

        AnsiString LIMITING;
        AnsiString LINES;
        AnsiString PORT;
        AnsiString START_TYPE;


        void LoadConfig();
        void SaveConfig();

        void CfgToDlg();


        void QueryStatus();
        bool Querying;

        AnsiString GetServiceStatus();

        bool IsWindows9X();

        char ServName[256];

        // SERVICE PART ******************************

        SC_HANDLE H1;
        void TryToOpenSCManager();
        AnsiString SCManagerErrMsg;
        void StaticResources();
        DWORD SCMErr;

        SERVICE_STATUS sstatus;

        bool CommandStart();
        bool CommandPause();
        bool CommandContinue();
        bool CommandStop();
        bool CommandUserDefinedReload();
        bool CommandQueryServiceStatus();

        enum BUTTON_STATE
        {
          BS_STARTED,
          BS_STOPPED,
          BS_PAUSED,
          BS_NONE,
          BS_REFRESHONLY
        };
        void SetButtonState( BUTTON_STATE );
        void HandleGetLastError();
        // *******************************************


public:		// User declarations
        __fastcall TServerMainForm(TComponent* Owner);
        __fastcall ~TServerMainForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TServerMainForm *ServerMainForm;
//---------------------------------------------------------------------------
#endif
