//-----------------------------------------------------------------------------
//  Copyright (c) by Antivari Software Design
//-----------------------------------------------------------------------------
//
//  Project name :
//  Subsystem    :
//  Module file  :
//  Compiler     :
//  Copied from  :
//  Created by   :
//
//-----------------------------------------------------------------------------
//  Description:
//
//
//
//-----------------------------------------------------------------------------
//  Changes:
//
//
//
//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// System
//------------------------------------------------------------------------------
#include "winsock2.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <io.h>

#include <Inifiles.hpp>
#include <SysUtils.hpp>
#include <StrUtils.hpp>

//------------------------------------------------------------------------------
// Shared headers
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Local headers
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Private headers
//------------------------------------------------------------------------------
#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TTicketService *TicketService;

//---------------------------------------------------------------------------
__fastcall TTicketService::TTicketService(TComponent* Owner)
	: TService(Owner)
{
   ReloadIniToFastConfig();

   TaskInProgress    = false;
   ReloadRequest     = false;

   MarkedForStop     = false;
   MarkedForPause    = false;
   MarkedForContinue = false;

   InitializeCriticalSection( &ticksrvCriticalSection );
   InitializeCriticalSection( &ticksrvLogCriticalSection );

}

__fastcall TTicketService::~TTicketService()
{
   DeleteCriticalSection( &ticksrvCriticalSection );
   DeleteCriticalSection( &ticksrvLogCriticalSection );
}


TServiceController __fastcall TTicketService::GetServiceController(void)
{
	return (TServiceController) ServiceController;
}

void __stdcall ServiceController(unsigned CtrlCode)
{
	TicketService->Controller(CtrlCode);
}
//---------------------------------------------------------------------------
// MAIN LOOP
//---------------------------------------------------------------------------
/*


//
// Controls
//
#define SERVICE_CONTROL_STOP                   0x00000001
#define SERVICE_CONTROL_PAUSE                  0x00000002
#define SERVICE_CONTROL_CONTINUE               0x00000003
#define SERVICE_CONTROL_INTERROGATE            0x00000004
#define SERVICE_CONTROL_SHUTDOWN               0x00000005
#define SERVICE_CONTROL_PARAMCHANGE            0x00000006
#define SERVICE_CONTROL_NETBINDADD             0x00000007
#define SERVICE_CONTROL_NETBINDREMOVE          0x00000008
#define SERVICE_CONTROL_NETBINDENABLE          0x00000009
#define SERVICE_CONTROL_NETBINDDISABLE         0x0000000A
#define SERVICE_CONTROL_DEVICEEVENT            0x0000000B
#define SERVICE_CONTROL_HARDWAREPROFILECHANGE  0x0000000C
#define SERVICE_CONTROL_POWEREVENT             0x0000000D
#define SERVICE_CONTROL_SESSIONCHANGE          0x0000000E

//
// Service State -- for CurrentState
//
#define SERVICE_STOPPED                        0x00000001
#define SERVICE_START_PENDING                  0x00000002
#define SERVICE_STOP_PENDING                   0x00000003
#define SERVICE_RUNNING                        0x00000004
#define SERVICE_CONTINUE_PENDING               0x00000005
#define SERVICE_PAUSE_PENDING                  0x00000006
#define SERVICE_PAUSED                         0x00000007

*/
void __fastcall TTicketService::ServiceExecute(TService *Sender)
{

   if ( CONFIG_START_TYPE == "0" )
      this->Controller( SERVICE_CONTROL_STOP );

   GoSendMessageToLog( "Aktiviran." );

   // Glavna servisna petlja
   while ( !Terminated )
   {
      if ( !TaskInProgress )
      {
         if ( ReloadRequest )
         {
            ReloadRequest = false;

            ReloadIniToFastConfig();

            // Gambit (1)
            int NewPort = StrToInt( CONFIG_PORT );
    		IdTCPServer->Active = false;
    		for( int x = 0; x < IdTCPServer->Bindings->Count; ++x )
    		   IdTCPServer->Bindings->Items[x]->Port = NewPort;
    		IdTCPServer->Active = true;


            // Message
            GoSendMessageToLog( "Konfiguracije je po zahtevu ponovo uitana." );
         }

         if ( MarkedForStop )
            this->Controller( SERVICE_CONTROL_STOP );
         else if ( MarkedForPause )
            this->Controller( SERVICE_CONTROL_PAUSE );
         else if ( MarkedForContinue )
            this->Controller( SERVICE_CONTROL_CONTINUE );

      }

      Sleep ( 500 );

      ServiceThread->ProcessRequests( false );
   }
}
//---------------------------------------------------------------------------
// END
//---------------------------------------------------------------------------

bool __fastcall TTicketService::DoCustomControl(unsigned CtrlCode)
{
   if ( CtrlCode == 200 )
   {
      ReloadRequest = true;
   }

   return ( true );
}


void __fastcall TTicketService::ServiceAfterInstall(TService *Sender)
{
   GoSendMessageToLog( "Instaliran." );
}

void __fastcall TTicketService::ServiceAfterUninstall(TService *Sender)
{
   GoSendMessageToLog( "Deinstaliran." );
}

void __fastcall TTicketService::ServiceStart(TService *Sender,
      bool &Started)
{
   IdTCPServer->DefaultPort = StrToInt( CONFIG_PORT );
   IdTCPServer->Active = true;
   // ...
   GoSendMessageToLog( "Pokrenut." );

   MarkedForPause    = false;
   MarkedForContinue = false;
   MarkedForStop     = false;

   Started = true;
}

void __fastcall TTicketService::ServicePause(TService *Sender,
      bool &Paused)
{
   if ( TaskInProgress )
   {
      MarkedForPause    = true;

      MarkedForContinue = false;
      MarkedForStop     = false;

      Paused = false;
   }
   else
   {
      IdTCPServer->Active = false;
      // ...
      GoSendMessageToLog( "Pauziran." );

      MarkedForPause    = false;
      MarkedForContinue = false;
      MarkedForStop     = false;

      Paused = true;
   }
}

void __fastcall TTicketService::ServiceContinue(TService *Sender,
      bool &Continued)
{
   IdTCPServer->DefaultPort = StrToInt( CONFIG_PORT );
   IdTCPServer->Active = true;
   // ...
   GoSendMessageToLog( "Nastavljen." );

   MarkedForPause    = false;
   MarkedForContinue = false;
   MarkedForStop     = false;

   Continued = true;
}

void __fastcall TTicketService::ServiceStop(TService *Sender,
      bool &Stopped)
{
   if ( TaskInProgress )
   {
      MarkedForStop     = true;

      MarkedForPause    = false;
      MarkedForContinue = false;

      Stopped = false;
   }
   else
   {
      IdTCPServer->Active = false;
      // ...
      GoSendMessageToLog( "Zaustavljen." );

      MarkedForPause    = false;
      MarkedForContinue = false;
      MarkedForStop     = false;

      Stopped = true;
   }
}

void __fastcall TTicketService::ServiceShutdown(TService *Sender)
{
   IdTCPServer->Active = false;
   // ...
   GoSendMessageToLog( "Nasilno zatvoren." );
}

void TTicketService::GoSendMessageToLog( AnsiString AEvent )
{
   // Otvori kriticnu sekciju i osiguraj sa RAII
   CSLock lock( &ticksrvLogCriticalSection );

   // Naziv LOG datoteke
   AnsiString LOG_FILE = ExtractFilePath( ParamStr(0) ) + "tickcfg.log";

   // Inicijalizuj StringList
   TStringList *StringList = NULL;

   // Optimisticko stanje
   bool IsStringListOK = true;

   // Osiguraj brisanje string liste
   try
   {
      // Osiguraj se protiv bilo koje greske
      try
      {
         // nova string lista
         StringList = new TStringList();

         // obrisi prethodne stavke
         StringList->Clear();

         // ucitaj LOG fajl u string listu
         try
         {
            // ako je fajl prethodno postojao
            if ( FileExists( LOG_FILE ) )
               StringList->LoadFromFile ( LOG_FILE );
         }
         catch ( const Exception &e )
         {
            IsStringListOK = false;
            LogMessage( "ticksrv.exe : GoSendMessageToLog() > LoadFromFile() > Exception" );
         }

         // ako nije bilo nikakvih gresaka
         if ( IsStringListOK )
         {
            // dodaj novi upis u string listu
            AnsiString NEW_ROW = "Ticket server : " + FormatDateTime( "dd-mm-yyyy, hh:nn:ss", Now() ) + " : " + AEvent;
            StringList->Add( NEW_ROW );
         }

         // Ako je sve bilo u redu
         if ( IsStringListOK  )
         {
            //  i ako treba da se lista skrati
            if ( CONFIG_LIMITING == "1" )
            {
               if ( StringList->Count > StrToInt( CONFIG_LINES ) )
               {
                  int TotalCount = StringList->Count - StrToInt( CONFIG_LINES );

                  try
                  {
                     for ( int i=0; i<TotalCount; i++ )
                        StringList->Delete( 0 );
                  }
                  catch ( const Exception &e )
                  {
                     IsStringListOK = false;
                     LogMessage( "ticksrv.exe : GoSendMessageToLog() > Delete(0) > Exception" );
                  }
               }
            }

            // ako je sve u redu
            if ( IsStringListOK )
            {
               // snimi nazad string listu u fajl
               try
               {
                  StringList->SaveToFile ( LOG_FILE );
               }
               catch (  const Exception &e )
               {
                  IsStringListOK = false;
                  LogMessage( "ticksrv.exe : GoSendMessageToLog() > SaveToFile()" );
               }
            }
         }
      }
      catch (  const Exception &e )
      {
         IsStringListOK = false;
         LogMessage( "ticksrv.exe : GoSendMessageToLog() > StringList = new TStringList()" );
      }

   }
   __finally
   {
      if ( StringList )
         delete StringList;
   }
}


void TTicketService::ReloadIniToFastConfig()
{
   TIniFile *pIni = NULL;

   try
   {
      pIni = new TIniFile( ExtractFilePath( ParamStr(0) ) + "tickcfg.ini" );

      CONFIG_LIMITING     = pIni->ReadString( "Log", "Limiting", "1" );
      CONFIG_LINES        = pIni->ReadString( "Log", "Lines", "500" );
      CONFIG_PORT         = pIni->ReadString( "Connections", "Port", "11059" );
      CONFIG_START_TYPE   = pIni->ReadString( "Server", "StartType", "0" );


      if ( (CONFIG_LIMITING != "1") && (CONFIG_LIMITING != "0") )
      {
         CONFIG_LIMITING = "1";
      }

      if ( (CONFIG_START_TYPE != "1") && (CONFIG_START_TYPE != "0") )
      {
         CONFIG_START_TYPE = "0";
      }

      try
      {
         int lines = StrToInt( CONFIG_LINES );

         if ( lines < 1 || lines > 32768 )
            CONFIG_LINES = "500";

      }
      catch ( const Exception &e )
      {
         CONFIG_LINES = "500";
         LogMessage( "ticksrv.exe : ReloadIniToFastConfig() > int lines = StrToInt( CONFIG_LINES )" );
      }

      try
      {
         int port = StrToInt( CONFIG_PORT );

         if ( port < 1 || port > 32768 )
            CONFIG_PORT = "11059";
      }
      catch ( const Exception &e )
      {
         CONFIG_PORT = "11059";
         LogMessage( "ticksrv.exe : ReloadIniToFastConfig() > int port = StrToInt( CONFIG_PORT )" );
      }
   }
   catch ( const Exception &e )
   {
      LogMessage( "ticksrv.exe : ReloadIniToFastConfig() > pIni = new TIniFile() || pIni->ReadString()" );
   }

   if ( pIni )
      delete pIni;


}

bool TTicketService::SetIniValue( AnsiString Section, AnsiString Key, AnsiString Value )
{
   bool Result = true;

   TIniFile *pIni = NULL;

   try
   {
      pIni = new TIniFile( ExtractFilePath( ParamStr(0) ) + "tickcfg.ini" );
      pIni->WriteString( Section, Key, Value );
   }
   catch ( const Exception &e )
   {
      Result = false;
   }

   if ( pIni )
      delete pIni;

   return ( Result );
}

void __fastcall TTicketService::IdTCPServerExecute(TIdPeerThread *AThread)
{
   TMemoryStream *InboxMemoryStream = new TMemoryStream;
   InboxMemoryStream->Position = 0;

   // RECEIVING TASKS ...
   int BytesToRead = AThread->Connection->ReadInteger();
   AThread->Connection->ReadStream( InboxMemoryStream, BytesToRead, false );

   InboxMemoryStream->Position = 0;

   // SENDING TASKS ...
   AThread->Connection->WriteInteger( InboxMemoryStream->Size );
   AThread->Connection->WriteStream( InboxMemoryStream, InboxMemoryStream->Size );

   delete InboxMemoryStream;
}
//---------------------------------------------------------------------------

