//*****************************************************************************
//  Copyright (c) by Antivari Software Design
//*****************************************************************************
//
//  Project name       :
//  Subsystem          :
//  Module file        :
//  Created by         :
//  Annotations        :
//
//
//*****************************************************************************
//  Description:
//
//
//
//*****************************************************************************
//  Changes:
//
//
//
//*****************************************************************************

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <SvcMgr.hpp>
#include <vcl.h>
#include <IdBaseComponent.hpp>
#include <IdComponent.hpp>
#include <IdTCPServer.hpp>


//---------------------------------------------------------------------------
class TTicketService : public TService
{
__published:    // IDE-managed Components
        TIdTCPServer *IdTCPServer;
        void __fastcall ServiceAfterInstall(TService *Sender);
        void __fastcall ServiceAfterUninstall(TService *Sender);
        void __fastcall ServiceContinue(TService *Sender, bool &Continued);
        void __fastcall ServiceExecute(TService *Sender);
        void __fastcall ServicePause(TService *Sender, bool &Paused);
        void __fastcall ServiceStart(TService *Sender, bool &Started);
        void __fastcall ServiceStop(TService *Sender, bool &Stopped);
        void __fastcall ServiceShutdown(TService *Sender);
        void __fastcall IdTCPServerExecute(TIdPeerThread *AThread);
private:        // User declarations

        CRITICAL_SECTION ticksrvCriticalSection;
        CRITICAL_SECTION ticksrvLogCriticalSection;

        bool ReloadRequest;
        bool TaskInProgress;

        bool MarkedForStop;
        bool MarkedForPause;
        bool MarkedForContinue;

        bool SetIniValue( AnsiString, AnsiString, AnsiString );

        // Fast Config
        void ReloadIniToFastConfig();

        AnsiString CONFIG_PORT;
        AnsiString CONFIG_LIMITING;
        AnsiString CONFIG_LINES;
        AnsiString CONFIG_START_TYPE;

        void GoSendMessageToLog( AnsiString AEvent );

public:         // User declarations
	__fastcall TTicketService(TComponent* Owner);
        __fastcall ~TTicketService();
        bool __fastcall DoCustomControl(unsigned CtrlCode);

	TServiceController __fastcall GetServiceController(void);

	friend void __stdcall ServiceController(unsigned CtrlCode);
};

class CSLock
{
public:
   LPCRITICAL_SECTION fcs;

   CSLock( LPCRITICAL_SECTION acs ) : fcs( acs )
   { if ( fcs ) EnterCriticalSection( fcs ); }

   ~CSLock()
   { if ( fcs ) LeaveCriticalSection( fcs ); }
};

//---------------------------------------------------------------------------
extern PACKAGE TTicketService *TicketService;
//---------------------------------------------------------------------------
#endif
